/*****************************************************************************
 * subdump command / version 1.00                                            *
 *---------------------------------------------------------------------------*
 * t@C : bdump.c                                                      *
 * Tv       : t@C̎wʒuwTCỸoCi_vo͂   *
 *---------------------------------------------------------------------------*
 * [usage]                                                                   *
 * > subdump t@C Jnʒu o̓TCY                                  *
 *---------------------------------------------------------------------------*
 * [return code]                                                             *
 * 0   : I                                                            *
 * 1   : s                                                            *
 * 2   : t@CȂ                                              *
 * 255 : ُI(͕WG[ɏo͂)                              *
 *****************************************************************************/

/*****************************************************************************
 * wb_t@Cǂݍ                                                    *
 *****************************************************************************/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define ERR_PRM 1
#define ERR_NOF 2
#define ERR_SYS 255

/*****************************************************************************
 * Definition of file static functions                                       *
 *****************************************************************************/
static void DumpOut();
static void PutUsage();

/*****************************************************************************
 * main()                                                                    *
 *****************************************************************************/
int main(argc,argv)
int argc;
char* argv[];
{
  FILE* fpInput;
  size_t szFile;
  size_t szStart;
  size_t szSize;

  /* `FbN */
  if(argc<4) {
    fprintf(stderr,"Argument error\n");
    PutUsage();
    return ERR_PRM;
  }

  szStart=(size_t)atoi(argv[2]);
  szSize=(size_t)atoi(argv[3]);

  /* t@CJ */
  fpInput=fopen(argv[1],"rb");
  if(fpInput==NULL) {
    fprintf(stderr,"File not found. (%s)\n",argv[1]);
    return ERR_NOF;
  }

  /* Check the file size */
  fseek(fpInput,0,SEEK_END);
  szFile=(size_t)ftell(fpInput);
  if(szFile<szStart || szFile<szStart+szSize) {
    fclose(fpInput);
    fprintf(stderr,"Argument error. (File size is %ld)\n",(long)szFile);
    PutUsage();
    return ERR_PRM;
  }

  /* Dump */
  fseek(fpInput,(long)szStart,SEEK_SET);
  fprintf(stdout,"\n<Dump of %ld-%ld>\n",(long)szStart,(long)szStart+szSize);
  DumpOut(fpInput,szSize);

  /* Finish */
  fclose(fpInput);
  return 0;
}

/*****************************************************************************
 * DumpOut()                                                                 *
 *****************************************************************************/
static void DumpOut(fpInput,szOutSize)
FILE* fpInput;
size_t szOutSize;
{
  char cOut[256];
  char cAsc;
  char cAscStr[17];
  char cBuf[16];
  char cWork[8];
  int i;
  size_t szRead;
  size_t szReal;
  size_t szTotal=0;
  int iAsc;
  int iEndFlag=0;

  fprintf(stdout,"ADDRESS  : +0 +1 +2 +3 +4 +5 +6 +7 - +8 +9 +A +B +C +D +E +F : ASCII\n");
  fprintf(stdout,"---------+---------------------------------------------------+-----------------\n");

  /* C[v */
  while((szRead=fread(cBuf,1,sizeof(cBuf),fpInput))!=0) {
    szReal=szRead;
    szTotal+=szRead;
    if(szTotal>=szOutSize) {
      szRead=szRead-(szTotal-szOutSize);
      iEndFlag=1;
    }
    memset(cAscStr,0,sizeof(cAscStr));
    sprintf(cOut,"%08X : ",(int)ftell(fpInput)-szReal);
    for(i=0;i<(int)szRead;i++) {
      cAsc=cBuf[i];
      iAsc=cBuf[i] & 0xff;
      sprintf(cWork,"%02X ",iAsc);
      strcat(cOut,cWork);
      if(iAsc>=0x20 && iAsc<=0x7e) {
          cAscStr[i]=iAsc;
      } else {
          cAscStr[i]='.';
      }
      if(i==7) {
          strcat(cOut,"- ");
      }
    }
    for(;i<16;i++) {
      strcat(cOut,"   ");
      if(i==7) {
        strcat(cOut,"- ");
      }
    }
    strcat(cOut,": ");
    strcat(cOut,cAscStr);
    fprintf(stdout,"%s\n",cOut);
    if(iEndFlag) break;
  }
}

static void PutUsage()
{
  fprintf(stderr,"[usage]\n");
  fprintf(stderr,"> subdump file-name start-point size\n");
}

/* End of subdump.c */
